Index: trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp
===================================================================
--- trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 405)
+++ trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 434)
@@ -522,206 +443,137 @@
         m_config_rsp_reop_fifo.init();
         
-        m_config_local_rsrcid_fifo.init();
-        m_config_local_rtrdid_fifo.init();
-        m_config_local_rpktid_fifo.init();
-        m_config_local_data_fifo.init();
-        m_config_local_rerror_fifo.init();
-        m_config_local_reop_fifo.init();
-
-        //Communication between DMA_CMD and DMA_RSP
-        r_dma_cmd_rsp_erase_req		=false;
-        r_dma_cmd_error_req         =false;
-        //Communication between DMA_CMD and TLB 
-        r_dma_tlb_req		        =false;
-        r_tlb_dma_untreated		    =false; 
-        //Communication betweeen TLB and CONFIG_CMD
-        r_config_tlb_req		    =false;
-        r_config_tlb_inval_vaddr	=false;
-	    r_dma_tlb_error_req         =false; 
-        r_tlb_error_type            =false;   
-        //Communication between CONFIG_CMD and CONFIG_RSP
-        r_config_cmd_rsp_erase_req  =false;
-        //Communication between TLB_MISS and MISS_INIT 
-        r_tlb_miss_init_req         =false;
-        r_miss_init_error           =false;
-        // Debug variables
-		m_debug_dma_rsp_fsm	        = false;
-		m_debug_dma_cmd_fsm         = false;
-        m_debug_dma_tlb_fsm         = false;
-        m_debug_config_cmd_fsm      = false;
-        m_debug_config_rsp_fsm      = false;
-        m_debug_miss_init_fsm       = false;
+        // SET/RESET Communication flip-flops 
+        r_dma_tlb_req		        = false;
+        r_config_tlb_req		    = false;
+        r_tlb_miss_req              = false;
+
+        // Debug variable
+		m_debug_activated	        = false;
         
-        r_irq_mask              = 0xFFFFFFFF;
-        r_irq_chosen            = 0;
+        for ( size_t n=0 ; n<32 ; n++ )
+        {
+            r_irq_pending[n]        = false;
+            r_irq_request[n]        = false;
+        }
           
 	    // activity counters
-	    m_cpt_total_cycles      = 0;
-        m_cpt_iotlb_read       = 0;             
-        m_cpt_iotlb_miss       = 0;             
-        m_cpt_iotlbmiss_transaction      = 0;    
-        m_cost_iotlbmiss_transaction      = 0;   
+	    m_cpt_total_cycles            = 0;
+        m_cpt_iotlb_read              = 0;             
+        m_cpt_iotlb_miss              = 0;             
+        m_cpt_iotlbmiss_transaction   = 0;    
+        m_cost_iotlbmiss_transaction  = 0;   
         
-        m_cpt_trt_dma_full          = 0;
-        m_cpt_trt_dma_full_cost     = 0;
-        m_cpt_trt_config_full          = 0;
-        m_cpt_trt_config_full_cost     = 0;
+        m_cpt_trt_dma_full            = 0;
+        m_cpt_trt_dma_full_cost       = 0;
+        m_cpt_trt_config_full         = 0;
+        m_cpt_trt_config_full_cost    = 0;
 
         for (uint32_t i=0; i<32 ; ++i) m_cpt_fsm_dma_cmd            [i]   = 0;
         for (uint32_t i=0; i<32 ; ++i) m_cpt_fsm_dma_rsp            [i]   = 0;
-        for (uint32_t i=0; i<32 ; ++i) m_cpt_fsm_dma_tlb            [i]   = 0;
-        for (uint32_t i=0; i<32 ; ++i) m_cpt_fsm_alloc_trt_dma      [i]   = 0;
+        for (uint32_t i=0; i<32 ; ++i) m_cpt_fsm_tlb                [i]   = 0;
         for (uint32_t i=0; i<32 ; ++i) m_cpt_fsm_config_cmd         [i]   = 0;
         for (uint32_t i=0; i<32 ; ++i) m_cpt_fsm_config_rsp         [i]   = 0;
-        for (uint32_t i=0; i<32 ; ++i) m_cpt_fsm_alloc_trt_config   [i]   = 0;
-        for (uint32_t i=0; i<32 ; ++i) m_cpt_fsm_miss_init          [i]   = 0;
+        for (uint32_t i=0; i<32 ; ++i) m_cpt_fsm_miss_wti_cmd       [i]   = 0;
+        for (uint32_t i=0; i<32 ; ++i) m_cpt_fsm_miss_wti_rsp       [i]   = 0;
+
         return;
     }
 
+    // default values for FIFOs
+    bool        dma_cmd_fifo_put      = false;
+    bool        dma_cmd_fifo_get      = false;
+
+    bool        dma_rsp_fifo_put      = false; 
+    bool        dma_rsp_fifo_get      = false; 
     
-    //bool        miss_unposted      = false;
-    bool        dma_cmd_fifo_put    = false;
-    bool        dma_cmd_fifo_get    = false;
-    bool        dma_rsp_fifo_put    = false; 
-    bool        dma_rsp_fifo_get    = false; 
-    
-    bool        config_cmd_fifo_put = false;
-    bool        config_cmd_fifo_get = false;
-    bool        config_rsp_fifo_put = false;
-    bool        config_rsp_fifo_get = false;
-    bool        config_local_fifo_put = false;
-    bool        config_local_fifo_get = false;
+    bool        config_cmd_fifo_put   = false;
+    bool        config_cmd_fifo_get   = false;
+
+    bool        config_rsp_fifo_put   = false;
+    bool        config_rsp_fifo_get   = false;
 
 #ifdef INSTRUMENTATION
     m_cpt_fsm_dma_cmd	        [r_dma_cmd_fsm.read()] ++;
     m_cpt_fsm_dma_rsp	        [r_dma_rsp_fsm.read() ] ++;
-    m_cpt_fsm_dma_tlb   	    [r_dma_tlb_fsm.read() ] ++;
-    m_cpt_fsm_alloc_trt_dma  	[r_alloc_trt_dma_fsm.read() ] ++;
+    m_cpt_fsm_tlb        	    [r_tlb_fsm.read() ] ++;
     m_cpt_fsm_config_cmd	    [r_config_cmd_fsm.read() ] ++;
     m_cpt_fsm_config_rsp	    [r_config_rsp_fsm.read() ] ++;
-    m_cpt_fsm_alloc_trt_config  [r_alloc_trt_config_fsm.read() ] ++;
-    m_cpt_fsm_miss_init	        [r_miss_init_fsm.read() ] ++;
+    m_cpt_fsm_miss_wti_cmd      [r_miss_wti_cmd_fsm.read() ] ++;
+    m_cpt_fsm_miss_wti_rsp      [r_miss_wti_rsp_fsm.read() ] ++;
 #endif
 
     m_cpt_total_cycles++;
 
-    m_debug_dma_cmd_fsm        = (m_cpt_total_cycles > m_debug_start_cycle) and m_debug_ok;
-    m_debug_dma_rsp_fsm         = (m_cpt_total_cycles > m_debug_start_cycle) and m_debug_ok;
-    m_debug_dma_tlb_fsm    = (m_cpt_total_cycles > m_debug_start_cycle) and m_debug_ok;
-    m_debug_config_cmd_fsm      = (m_cpt_total_cycles > m_debug_start_cycle) and m_debug_ok;
-    m_debug_config_rsp_fsm     = (m_cpt_total_cycles > m_debug_start_cycle) and m_debug_ok;
-    m_debug_miss_init_fsm       = (m_cpt_total_cycles > m_debug_start_cycle) and m_debug_ok;
-
-    /////////////////////////////////////////////////////////////////////
-    // The DMA_CMD_FSM controls the following ressources:
-    // - r_dma_cmd_fsm
-    // - r_dma_srcid
-    // - r_dma_tlb_req (set)
-    // - r_tlb_dma_untreated (reset)
-    // - r_dma_cmd_rsp_erase_req (set)
+    m_debug_activated  = (m_cpt_total_cycles > m_debug_start_cycle) and m_debug_ok;
+
+    //////////////////////////////////////////////////////////////////////////////
+    // The DMA_CMD_FSM handles DMA transactions requested by peripherals
+    // It makes the address translation if IOMMU is activated.
     ///////////////////////////////////////////////////////////////////////////////
 
     switch( r_dma_cmd_fsm.read() ) 
     {
-    //////////////
-    case DMA_CMD_IDLE:
-    {
-        // Treats an eventual request from TLB_MISS fsm 
-        // to send a command whose miss treatment is now finished
-        if ( r_tlb_dma_untreated.read() )
-        {
-            r_dma_cmd_fsm    = DMA_CMD_TRT_LOCK;//before posting we must update TRT
-            r_dma_cmd_fsm_save = DMA_CMD_IDLE;
-            r_miss_interrupt = true;
-            break;
-        }
-        // Error during miss treatment
-        else if (r_dma_tlb_error_req.read())
-        {
-            r_iommu_etr     = r_tlb_error_type.read(); 
-            r_iommu_bvar    = r_iotlb_vaddr.read();
-            r_iommu_bad_id  = r_miss_srcid.read();
-            // For DMA_RSP FSM
-            if(r_miss_cmd.read() == vci_param_io::CMD_WRITE) r_dma_error_type = WRITE_ERROR;
-            else r_dma_error_type = READ_ERROR;
-            r_dma_error_trdid   = r_miss_trdid.read(); 
-            r_dma_error_pktid   = r_miss_pktid.read(); 
- 
-            r_dma_tlb_error_req = false; 
-            r_dma_cmd_fsm   = DMA_CMD_ERROR;
-        }
-
-        if ( p_vci_tgt_dma.cmdval.read() )
+    //////////////////
+    case DMA_CMD_IDLE:  // waiting DMA VCI transaction
+    {
+        if ( p_vci_tgt_iox.cmdval.read() ) // compute physical address 
         { 
-            if ( not r_iommu_active.read()) 	// iotlb not activated 
+            if ( not r_iommu_active.read() ) 	// tlb not activated 
             {
-                // physical address
-                r_dma_paddr = (paddr_t)p_vci_tgt_dma.address.read();
-                r_dma_cmd_fsm	= DMA_CMD_TRT_LOCK;
+#if DEBUG_DMA_CMD
+if( m_debug_activated )
+std::cout << "  <IOB DMA_CMD_IDLE> IOMMU not activated" << std::endl;
+#endif
+                // put DMA transaction into DMA_CMD fifo
+                r_dma_cmd_paddr = p_vci_tgt_iox.address.read();
+                r_dma_cmd_fsm   = DMA_CMD_FIFO_PUT_CMD;
             }
-            else if (r_dma_tlb_fsm.read() == DMA_TLB_IDLE ||
-                     r_dma_tlb_fsm.read() == DMA_TLB_WAIT_TRANSACTION )	  // iotlb activated
+            else if (r_tlb_fsm.read() == TLB_IDLE ||
+                     r_tlb_fsm.read() == TLB_WAIT )	  // tlb access possible
             {
-                paddr_t	paddr;
-
-                
-                // We compute physical address and check access rights :
-                // - If MMU not activated :the physical address is equal to the virtual 
-                //address (identity mapping) and there is no access rights checking
-                // - If MMU activated : cacheability is defined by the C bit in the PTE,
-                //   the physical address is obtained from the TLB, and the access rights are
-                //   defined by the W bit in the PTE.
-
-                paddr_t		iotlb_paddr;
+                vci_addr_t	iotlb_paddr;
                 pte_info_t  iotlb_flags; 
                 size_t      iotlb_way;  
                 size_t      iotlb_set;
-                paddr_t     iotlb_nline;
-                bool		iotlb_hit   = false;;  
-
+                vci_addr_t  iotlb_nline;
+                bool		iotlb_hit;  
 
 #ifdef INSTRUMENTATION
 m_cpt_iotlb_read++;
 #endif
-
-                iotlb_hit = r_iotlb.translate(p_vci_tgt_dma.address.read(),
-                                            &iotlb_paddr,
-                                            &iotlb_flags,
-                                            &iotlb_nline,// unused
-                                            &iotlb_way,	 // unused
-                                            &iotlb_set );// unused
+                iotlb_hit = r_iotlb.translate(p_vci_tgt_iox.address.read(),
+                                              &iotlb_paddr,
+                                              &iotlb_flags,
+                                              &iotlb_nline,  // unused
+                                              &iotlb_way,	 // unused
+                                              &iotlb_set );  // unused
             
-            
-                if ( iotlb_hit )	// tlb hit
+                if ( iotlb_hit )	                             // tlb hit
                 { 
-                    paddr       = iotlb_paddr;
-					
-                    // access rights checking 
-                    if ( not iotlb_flags.w and 
-                        (p_vci_tgt_dma.cmd.read() == vci_param_io::CMD_WRITE) ) 
+                    if ( not iotlb_flags.w and    // access right violation 
+                        (p_vci_tgt_iox.cmd.read() == vci_param_ext::CMD_WRITE) ) 
                     {
-                        r_iommu_etr     = MMU_WRITE_ACCES_VIOLATION;  
-                        r_iommu_bvar    = p_vci_tgt_dma.address.read();
-                        r_iommu_bad_id  = p_vci_tgt_dma.srcid.read();
-                        r_dma_cmd_fsm   = DMA_CMD_ERROR;
-                        // For DMA_RSP
-                        r_dma_error_type    = WRITE_ERROR; 
-                        r_dma_error_trdid   = p_vci_tgt_dma.trdid.read(); 
-                        r_dma_error_pktid   = p_vci_tgt_dma.pktid.read(); 
+                        // put DMA response error into DMA_RSP fifo
+                        r_iommu_etr      = MMU_WRITE_ACCES_VIOLATION;  
+                        r_iommu_bvar     = p_vci_tgt_iox.address.read();
+                        r_iommu_bad_id   = p_vci_tgt_iox.srcid.read();
+                        r_dma_cmd_fsm    = DMA_CMD_FIFO_PUT_RSP;
 #if DEBUG_DMA_CMD
-if( m_debug_dma_cmd_fsm )
-{
-    std::cout << "  <IOB.DMA_CMD_IDLE> HIT in iotlb, but writable violation" << std::endl;
-}
-#endif
-                    break;
+if( m_debug_activated )
+std::cout << "  <IOB DMA_CMD_IDLE> TLB HIT but writable violation" << std::endl;
+#endif
                     }
-
-                    // Physical address registration 
-                    r_dma_paddr   = paddr;			
-                    r_dma_cmd_fsm	= DMA_CMD_TRT_LOCK;
-                }
-                // TLB miss: we enter TLB_MISS treatment sub-fsm
-                else 
+                    else                         // no access rights violation
+                    {
+#if DEBUG_DMA_CMD
+if( m_debug_activated )
+std::cout << "  <IOB DMA_CMD_IDLE> TLB HIT" << std::endl;
+#endif
+                    // put DMA transaction into DMA_CMD fifo
+                    r_dma_cmd_paddr   = iotlb_paddr;			
+                    r_dma_cmd_fsm     = DMA_CMD_FIFO_PUT_CMD;
+                    }
+                }
+                else                                             // TLB miss
                 {
 
@@ -729,32 +581,12 @@
 m_cpt_iotlb_miss++;
 #endif
-                    if( r_dma_tlb_req.read() || r_tlb_dma_untreated.read() || r_dma_tlb_error_req.read() )
-                    {
-                        // There's already a ongoing request
-                        // or a completed request but not yet put on FIFO.
-                        // We stay blocked
-                        r_dma_cmd_fsm = DMA_CMD_TLB_MISS_WAIT;
+                        // register virtual address, and send request to TLB FSM 
+		                r_dma_cmd_vaddr = p_vci_tgt_iox.address.read();
+                        r_dma_tlb_req   = true;
+                        r_dma_cmd_fsm   = DMA_CMD_MISS_WAIT;
 #if DEBUG_DMA_CMD
-if( m_debug_dma_cmd_fsm )
-{
-    std::cout << "  <IOB.DMA_CMD_IDLE> MISS in iotlb. There is a pending request." << std::endl;
-}
-#endif
-                    }
-                    else
-                    {
-                        // We register request virtual address, to be used by DMA_TLB_MISS FSM
-		                r_iotlb_vaddr = p_vci_tgt_dma.address.read();
-                        assert((r_dma_cmd_count.read() == 0)
-                                and "ERROR: TRT counter should be 0");
-                        r_dma_tlb_req   = true;
-                        r_dma_cmd_fsm   = DMA_CMD_TLB_MISS_STORE;
-#if DEBUG_DMA_CMD
-if( m_debug_dma_cmd_fsm )
-{
-    std::cout << "  <IOB.DMA_CMD_IDLE> MISS in iotlb. No pending request." << std::endl;
-}
-#endif
-                    }
+if( m_debug_activated )
+std::cout << "  <IOB DMA_CMD_IDLE> TLB MISS" << std::endl;
+#endif
                 } // end !hit 
             } // end if tlb_activated
